<?php

namespace Schaffen\SerasaRemessa\Http\Advanced\PF\Blocks;

use Schaffen\SerasaRemessa\Utils\Record;
use Schaffen\SerasaRemessa\Utils\RecordColumn;
use Schaffen\SerasaRemessa\Utils\Util;

class RegB364 extends Record {
    /**
     * @var array Lista de colunas esperadas para o bloco
     */   
    protected $templateColumns = [
       
        [
            'name' => "type_rule",
            'position' => 1,
            'size' => 4,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "dt_occur",
            'position' => 5,
            'size' => 8,
            'type' =>  RecordColumn::TYPE_NUMERIC,
        ],
        [
            'name' => "nature",
            'position' => 13,
            'size' => 20,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "main",
            'position' => 33,
            'size' => 1,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "currency_type",
            'position' => 34,
            'size' => 3,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "value",
            'position' => 37,
            'size' => 9,
            'type' =>  RecordColumn::TYPE_NUMERIC,
        ],
        [
            'name' => "distributor",
            'position' => 46,
            'size' => 4,
            'type' =>  RecordColumn::TYPE_NUMERIC,
        ],
        [
            'name' => "court",
            'position' => 50,
            'size' => 4,
            'type' =>  RecordColumn::TYPE_NUMERIC,
        ],
        [
            'name' => "city",
            'position' => 54,
            'size' => 25,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "state",
            'position' => 79,
            'size' => 2,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "amount_occur",
            'position' => 81,
            'size' => 5,
            'type' =>  RecordColumn::TYPE_NUMERIC,
        ],
        [
            'name' => "sub_judice",
            'position' => 86,
            'size' => 1,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "filler_1",
            'position' => 87,
            'size' => 29,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
    ];


    public function __construct($values = null) {
        $this->createColumns();
    }


}