<?php

namespace Schaffen\SerasaRemessa\Http\Advanced\PJ\SubTypes\F900;

use Schaffen\SerasaRemessa\Utils\Record;
use Schaffen\SerasaRemessa\Utils\RecordColumn;
use Schaffen\SerasaRemessa\Utils\Util;

class SubTypeREHJ_1 extends Record {
    public $name = "riskscoring_value_calc";
    
    public $templateColumns = [
        
        [
            'name' => "type_rule",
            'position' => 1,
            'size' => 4,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "code_cons",
            'position' => 5,
            'size' => 4,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "sub_tip",
            'position' => 9,
            'size' => 3,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "data",
            'position' => 12,
            'size' => 8,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "hora",
            'position' => 20,
            'size' => 8,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "fator",
            'position' => 28,
            'size' => 4,
            'type' =>  RecordColumn::TYPE_NUMERIC,
        ],
        [
            'name' => "prinad",
            'position' => 32,
            'size' => 5,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "msg",
            'position' => 37,
            'size' => 78,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
        [
            'name' => "porte",
            'position' => 115,
            'size' => 1,
            'type' =>  RecordColumn::TYPE_ALPHANUMERIC,
        ],
    ];

    public function __construct($values = null) {
        $this->createColumns();

        
        if($values !== null) {
            $this->setValues($values);
        }
    }

    public function setValues($values) {
        $newValues = $this->getValues();
        
        $newValues['type_rule'] = substr($values, 0, 4);
        $newValues['code_cons'] = substr($values, 4, 4);
        $newValues['sub_tip'] = substr($values, 8, 3);
        $newValues['data'] = substr($values, 11, 8);
        $newValues['hora'] = substr($values, 19, 8);
        $newValues['fator'] = substr($values, 27, 4);
        $newValues['prinad'] = substr($values, 31, 5);
        $newValues['msg'] = substr($values, 36, 78);
        $newValues['porte'] = substr($values, 114, 1);
        
        $this->setColumnsValues($newValues);
    }
}